(function(root, factory) {
    if (typeof define === "function" && define.amd) {
        // AMD. Register as an anonymous module.
        define(["lodash"], function(_) {
            return factory(_, root);
        });
    } else if (typeof module === "object" && module.exports) {
        // Node, or CommonJS-Like environments
        module.exports = factory(require("lodash"));
    } else {
        // Browser globals
        root.riveter = factory(root._, root);
    }
}(this, function(_, global, undefined) {

    var slice = Array.prototype.slice;

    var riveter = function() {
        var args = slice.call(arguments, 0);
        while (args.length) {
            riveter.rivet(args.shift());
        }
    };

    //import("deepExtend.js");
    //import("riveter.base.js");

    return riveter;
}));