# WorkflowGen hooks Mocha tests

## Requirements
- WorkflowGen configuration parameters
  - In General / Security , `Workflow engine service default identity` must contain a valid WorkflowGen user account. This will be the default user identity executing the hooks operations. This setting refers to the key `EngineServiceImpersonificationUsername` in the web.config file. e.g. `<add key="EngineServiceImpersonificationUsername" value="wfgen_admin" />`

  - In Integration / Security, `System operations allowed users (usernames separated by commas)` must also contain the same account as defined above in `Workflow engine service default identity`. This setting refers to the key `ProcessesRuntimeWebServiceAllowedUsers` in the web.config file. e.g. `<add key="ProcessesRuntimeWebServiceAllowedUsers" value="wfgen_admin" />`

  - The anonymous authentication must be enabled for the `/wfgen/hooks` web application.

## Installation
1. In the SQL Server Configuration Manager, enable the TCP/IP protocol for the MSSQLSERVER service and restart the MSSQLSERVER service.
2. Set the following environmental variables (using the command prompt). If they are not set, they will take their default value that have been assigned in the `config.test.js` file.
    - `TestDbServer`: Database connection server. 
    - `TestDbAdminUserName`: Database connection administrator username. 
    - `TestDbAdminUserPassword`: Database connection administrator password.
    - `TestDbUserName`: Database connection username. 
    - `TestDbUserPassword`: Database connection password.
    - `TestDbName`: Database name.
    - `TestDbPort`: Database connection port.
    - `TestInstallScriptPath`: The local path where the SQL creation scripts are located. The folder should contains the following script files
      - Create_WFG-V7-0_SQL_Tables.sql
      - Create_WFG-V7-0_SQL_PKeys.sql
      - Create_WFG-V7-0_SQL_FKeys.sql
      - Create_WFG-V7-0_SQL_Indexes.sql
      - Create_WFG-V7-0_SQL_Triggers.sql
      - Create_WFG-V7-0_SQL_Const.sql

3. Change the values of the `Initial Catalog`, `User ID`, and `Password` properties of the MainDbSource connection string in the `/wfgen/web.config` file to the respective `test.databaseConnection.database`, `test.databaseConnection.user`, and `test.databaseConnection.password` values specified in the `config.test.js` file. Note that the WorkflowGen site won't be functional until you reset the connection string with the previously existing values.

## Database scripts
Using the command prompt, go to the `hooks` application.

To create a new database for the tests, execute the following commands from the command prompt (using `npm run <command>`):
- `test:db:create`: Create the database, login, user, schema, tables, constraints, indexes and triggers.
- `test:db:init`: Delete the database records if they exist, and insert the constants and the test data sets.

After having run the tests, if you want to run them again, execute the `test:db:init` command to reinitialize the test data sets.

The following commands are also available
- `test:db:reset`: Drop and create the database and all its objects.
- `test:db:drop`: Drop the  database and all its content.

## Launch the tests
Once the database is prepared, you can run the Mocha test suites in one of the following modes:
- `Standalone`:  Launches a separate web server (server.js) to host the hooks web application for the Mocha test suites.
- `WorkflowGen`:  Uses the localhost WorkflowGen hooks web application for the Mocha test suites. In this case, you should update the `test.server.port` setting in the `config.test.js` file by adding the WorkflowGen application port. 

To launch the tests, execute the following line in the command prompt: `npm test`