var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);

describe('RemoveComment', function () {
  
  it('should remove a comment', function (done) {
    chai.request(url)
      .post('/')
      .send({
        'operation': 'removeComment',
        'args': {
          'input': {
            'id': 'Q29tbWVudDo1LS0tMQ=='
          }
        }
      })
      .end(function (err, res) {
        res.should.have.status(200);
        res.should.be.json;
        res.body.should.have.property('clientMutationId');
        expect(res.body.clientMutationId).to.be.a('null');

        done();
      });
  });

  it("should return the comment removed", function (done) {
    chai.request(url)
      .post('/')
      .send({
        'operation': 'getComment',
        'args': {
          'id': 'Q29tbWVudDo1LS0tMQ=='
        }
      })
      .end(function (err, res) {
        res.should.have.status(500);
        res.should.be.json;

        res.body.should.have.property('error');
        res.body.error.should.be.a('string');

        expect(res.body.error).to.contain('The comment does not exist.');

        done();
      });
  });
});
