var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('DeleteUser', function () {
  
    it('should delete a user', function (done) {
      chai.request(url)
      .post('/')
      .send({
      'operation': 'deleteUser',
        'args': {
          'input': {
            'id': 'VXNlcjo1'
          }
        }
      })
      .end(function (err, res) {
        res.should.have.status(200);
        res.should.be.json;

        res.body.should.have.property('clientMutationId');
        expect(res.body.clientMutationId).to.be.null;

        done();
      });
    });
    
    it('should verify the deleted user', function (done) {
        chai.request(url)
        .post('/')
        .send({
          'operation': 'getUser',
          'args': {
            'id': 'VXNlcjo1'
          }
        })
        .end(function (err, res) {
          res.should.have.status(500);
          res.should.be.json;
          res.body.should.have.property('error');
          res.body.error.should.be.a('string');
          expect(res.body.error).to.contain('The user does not exist');
          done();
        });
    });

    it('should get an error when the user does not exist', function (done) {
        chai.request(url)
        .post('/')
        .send({
        'operation': 'deleteUser',
          'args': {
            'input': {
              'id': 'VXNlcjo5OTk5'
            }
          }
        })
        .end(function (err, res) {
          res.should.have.status(500);
          res.should.be.json;
  
          res.body.should.have.property('error');
          expect(res.body.error).to.contain('The user does not exist');

          done();
        });
      });
});
