var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetAction', function () {

    it('should get an action given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getAction',
            'args' : {
                'id' : 'QWN0aW9uOjEtLS0x'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateActionProperties(res.body);

            // Values validation
            expect(res.body).to.include({ id:'QWN0aW9uOjEtLS0x', name: '1-INITIATES' });

            done();
        });
    });
});
