var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetActionData', function(){

    it('should get an action data given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getActionData',
            'args' : {
                'id' : 'QWN0aW9uRGF0YTo2LS0tMS0tLTQ='
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateActionDataProperties(res.body);

            // Values validation
            expect(res.body).to.include({ id:'QWN0aW9uRGF0YTo2LS0tMS0tLTQ=' , name:'FORM_DRAFT'});

            done();
        });
    });
});
