var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var constants = require('../../constants');
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetApplicationParameter', function () {
  it('should get an application parameter given its ID', function (done) {
    chai.request(url)
    .post('/')
    .send({
      'operation': 'getApplicationParameter',
      'args': {
        'id': 'QXBwbGljYXRpb25QYXJhbWV0ZXI6MTMtLS0y'
      } 
    })
    .end(function (err, res) {
      res.should.have.status(200);
      res.should.be.json;
      utils.validateApplicationParameterProperties(res.body);
      expect(res.body.id).to.be.equal('QXBwbGljYXRpb25QYXJhbWV0ZXI6MTMtLS0y');
      expect(res.body.name).to.be.equal('NOTIFY_PARTICIPANT');
      expect(res.body.description).to.be.equal('Notify participant');
      expect(res.body.direction).to.be.equal('IN');
      expect(res.body.dataType).to.be.equal('TEXT');
      expect(res.body.isRequired).to.be.equal(false);
      expect(res.body.isDefault).to.be.equal(true);
      done();
    });
  });
});