var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var constants = require('../../constants');
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetApplicationParameters', function () {
  it('should get the application parameters given the application ID', function (done) {
    chai.request(url)
      .post('/')
      .send({
        'operation': 'getApplicationParameters',
        'args': {
          'id': 'QXBwbGljYXRpb246MTg='
        }
      })
      .end(function (err, res) {
        res.should.have.status(200);
        res.should.be.json;
        utils.validateApplicationParametersPageListProperties(res.body, 4);
        done();
      });
  });
  it('should get the application parameters given the application name', function (done) {
    chai.request(url)
      .post('/')
      .send({
        'operation': 'getApplicationParameters',
        'args': {
          'name': 'COPYDATA'
        }
      })
      .end(function (err, res) {
        res.should.have.status(200);
        res.should.be.json;
        utils.validateApplicationParametersPageListProperties(res.body, 4);
        done();
      });
  });
});
