var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetCategory', function () {
  it('should get a category given its ID', function (done) {
    chai.request(url)
      .post('/')
      .send({
        'operation': 'getCategory',
        'args': {
          'id': 'Q2F0ZWdvcnk6MQ=='
        }
      })
      .end(function (err, res) {
        res.should.have.status(200);
        res.should.be.json;

        utils.validateCategoryProperties(res.body);

        // Values validation
        expect(res.body).to.include({ id: 'Q2F0ZWdvcnk6MQ==', name: 'FINANCES', description: 'FINANCES', userId: null, onBehalfOf: null});
        
        done();
      });
  });
});
