var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);
    
describe('GetDelegableProcessParticipant', function () {
    it('should get a delegable process participant given its ID ', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getDelegableProcessParticipant',
            'args': {
                'id' : 'RGVsZWdhYmxlUHJvY2Vzc1BhcnRpY2lwYW50OjItLS00'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateDelegableProcessParticipantProperties(res.body);
            
            // Values validation
            expect(res.body).to.include({ processId:'UHJvY2Vzczoy', participantId:'TG9jYWxQcm9jZXNzUGFydGljaXBhbnQ6NA=='});

            done();
        });
    });
});
