var chai = require('chai');
var chaiHttp = require('chai-http');
var chaiThings = require('chai-things');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);
chai.use(chaiThings);
    
describe('GetDelegators', function () {
    it('should get viewer\'s delegators', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getDelegators',
            'args': {
                'userId': 'VXNlcjox'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;
            
            validateDelegatorsProperties(res, 1);

            expect(res.body.items[0]).to.equal('VXNlcjoy');

        done();
        });
    });

    it('should get john_smith\'s delegators', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getDelegators',
            'args': {
                'userId': 'VXNlcjoz'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            validateDelegatorsProperties(res, 2);

            expect(res.body.items[0]).to.equal('VXNlcjox');
            expect(res.body.items[1]).to.equal('VXNlcjoy');

        done();
        });
    });
});

function validateDelegatorsProperties(res, totalCount)
{
    // Properties
    res.body.should.have.property('totalCount');
    res.body.should.have.property('items');

    // Count
    expect(res.body.items).to.have.lengthOf(totalCount);
    expect(res.body.totalCount).to.equal(totalCount);

    // Array validation
    res.body.items.should.be.a('array');
}
