var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetGlobalParticipant', function () {
    
    it('should get a global participant given its name', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getGlobalParticipant',
            'args' : {
                'name' : 'DEFAULT_PROCESSMANAGER'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateParticipantProperties(res.body);

            // Values validation
            expect(res.body).to.include({ id:'R2xvYmFsUGFydGljaXBhbnQ6MQ==', name: 'DEFAULT_PROCESSMANAGER' });

            done();
        });
    });
});