var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);

describe('GetGlobalParticipanDirectoryAssociations', function () {
    
    it('should get participant directory associations by global participant ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getGlobalParticipanDirectoryAssociations',
            'args' : {
                'participantId' : 'R2xvYmFsUGFydGljaXBhbnQ6MQ=='
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            // TODO
            var totalCount = 0;
            
            // Properties
            res.body.should.have.property('totalCount');
            res.body.should.have.property('items');

            // Count
            expect(res.body.items).to.have.lengthOf(totalCount);
            expect(res.body.totalCount).to.equal(totalCount);
            
            done();
        });
    });
});