var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);

describe('GetGlobalParticipantUserAssociations', function () {
    
    it('should get participant user associations by global participant ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getGlobalParticipantUserAssociations',
            'args' : {
                'participantId' : 'R2xvYmFsUGFydGljaXBhbnQ6MQ=='
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;
            
            var totalCount = 2;
            
            // Properties
            res.body.should.have.property('totalCount');
            res.body.should.have.property('items');

            // Count
            expect(res.body.items).to.have.lengthOf(totalCount);
            expect(res.body.totalCount).to.equal(totalCount);

            // Array validation
            res.body.items.should.be.a('array');

            // Values validation
            expect(res.body.items[0]).to.include({ id:'VXNlcjo3', userName: 'garry_poole' });
            expect(res.body.items[1]).to.include({ id:'VXNlcjox', userName: 'wfgen_admin' });

            done();
        });
    });
});