var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetLocalProcessParticipant', function () {
    
    it('should get a local process participant given its name, processName and processVersion', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getLocalProcessParticipant',
            'args' : {
                'name' : 'LEVEL_2',
                'processName' : 'TEST_2_LEVELS_APPROVAL',
                'processVersion' : 1
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateParticipantProperties(res.body);

            // Values validation
            expect(res.body).to.include({ id:'TG9jYWxQcm9jZXNzUGFydGljaXBhbnQ6Ng==', name: 'LEVEL_2' });

            done();
        });
    });
});