var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);

describe('GetLocalProcessParticipanGroupAssociations', function () {
    
    it('should get participant group associations by local process participant ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getLocalProcessParticipanGroupAssociations',
            'args' : {
                'participantId' : 'TG9jYWxQcm9jZXNzUGFydGljaXBhbnQ6NQ=='
            } 
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            // TODO
            var totalCount = 0;
            
            // Properties
            res.body.should.have.property('totalCount');
            res.body.should.have.property('items');

            // Count
            expect(res.body.items).to.have.lengthOf(totalCount);
            expect(res.body.totalCount).to.equal(totalCount);

            done();
        });
    });
});