var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);

describe('GetLocalProcessParticipantUserAssociations', function () {
    
    it('should get participant user associations by local process participant ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getLocalProcessParticipantUserAssociations',
            'args' : {
                'participantId' : 'TG9jYWxQcm9jZXNzUGFydGljaXBhbnQ6NQ=='
            }            
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            var totalCount = 3;
            
            // Properties
            res.body.should.have.property('totalCount');
            res.body.should.have.property('items');

            // Count
            expect(res.body.items).to.have.lengthOf(totalCount);
            expect(res.body.totalCount).to.equal(totalCount);

            // Array validation
            res.body.items.should.be.a('array');

            // Values validation
            expect(res.body.items[0]).to.include({ id:'VXNlcjoz', userName: 'john_smith' });
            expect(res.body.items[1]).to.include({ id:'VXNlcjoy', userName: 'mark_twain' });
            expect(res.body.items[2]).to.include({ id:'VXNlcjox', userName: 'wfgen_admin' });

            done();
        });
    });
});