var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetParticipant', function () {

    it('should get a participant given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getParticipant',
            'args' : {
                'id' : 'TG9jYWxQcm9jZXNzUGFydGljaXBhbnQ6Ng=='
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateParticipantProperties(res.body);
            
            // Values validation
            expect(res.body).to.include({ id:'TG9jYWxQcm9jZXNzUGFydGljaXBhbnQ6Ng==', name: 'LEVEL_2' });

            done();
        });
    });
});