var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetProcess', function () {

    it('should get a process given its name and version', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getProcess',
            'args': {
                'name': "TEST_SIMPLE_APPROVAL_LOOP",
                'version' : 1
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateProcessProperties(res.body);

            // Values validation
            expect(res.body).to.include({ id:'UHJvY2Vzczoz', name: 'TEST_SIMPLE_APPROVAL_LOOP' });

            done();
        });
    });
});