var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
chai.use(chaiHttp);

describe('GetProcessData', function () {

    it('should get a process data given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getProcessData',
            'args': {
                'id' : 'UHJvY2Vzc0RhdGE6MS0tLTY='
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            // Values validation
            expect(res.body).to.include({ id:'UHJvY2Vzc0RhdGE6MS0tLTY=', name: 'APPROVAL_DECISION' });

            done();
        });
    });
});