var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetRequest', function(){

    it('should get a request given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getRequest',
            'args' : {
                'id' : 'UmVxdWVzdDo5'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateRequestProperties(res.body);

            expect(res.body).to.include({ id:'UmVxdWVzdDo5', name: 'TEST_SIMPLE_APPROVAL #9' });

            done();
        });
    });

    it('should get a request given its number', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getRequest',
            'args' : {
                'number' : 7
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;
            
            utils.validateRequestProperties(res.body);

            expect(res.body).to.include({ id:'UmVxdWVzdDo3', name: 'TEST_SIMPLE_APPROVAL #7' });

            done();
        });
    });
});
