var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetRequestData', function(){
    it('should get a request data given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getRequestData',
            'args' : {
                'id' : 'UmVxdWVzdERhdGE6MS0tLTE0'
            }
        })
        .end(function (err, res) {

            res.should.have.status(200);
            res.should.be.json;

            utils.validateRequestDataProperties(res.body);

            expect(res.body).to.include({ id:'UmVxdWVzdERhdGE6MS0tLTE0' , name:'FORM_ARCHIVE'});

            done();
        });
    });
});
