var chai = require('chai');
var chaiHttp = require('chai-http');
var expect = require('chai').expect;
var should = chai.should();
var utils = require('../../utils');
chai.use(chaiHttp);

describe('GetUser', function () {

    it('should get an user given its ID', function (done) {
        chai.request(url)
        .post('/')
        .send({
            'operation': 'getUser',
            'args': {
                'id': "VXNlcjo1"
            }
        })
        .end(function (err, res) {
            res.should.have.status(200);
            res.should.be.json;

            utils.validateUserProperties(res.body);

            expect(res.body).to.include({ id:'VXNlcjo1', userName: 'jane_doe', lastName: "Doe", firstName: "Jane", email: "jane.doe@company.com", directoryId: "RGlyZWN0b3J5OjI=" });
            
            done();
        })
    });

});