﻿using System;
using System.Data;
using System.IO;
using System.Configuration;
using System.Globalization;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using WorkflowGen.My.Web.UI.WebForms;
using WorkflowGen.My.Web.UI.WebControls;

public partial class _Default : WorkflowPage
{

    // Constructor
    public _Default() : base()
    {
        this.IsSessionLess = true;

    }

    // PageLoad
    protected void Page_Load(object sender, EventArgs e)
    {

        // If exist, use GlobalResources for error message raises by WorkflowGen.My

        string RequiredFieldsErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "RequiredFieldsErrorMessage");
        if (!String.IsNullOrEmpty(RequiredFieldsErrorMessage))
            this.RequiredFieldsErrorMessage = RequiredFieldsErrorMessage;

        string InvalidNumberErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidNumberErrorMessage");
        if (!String.IsNullOrEmpty(InvalidNumberErrorMessage))
            this.InvalidNumberErrorMessage = InvalidNumberErrorMessage;

        string InvalidCurrencyErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidCurrencyErrorMessage");
        if (!String.IsNullOrEmpty(InvalidCurrencyErrorMessage))
            this.InvalidCurrencyErrorMessage = InvalidCurrencyErrorMessage;

        string InvalidDateErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidDateErrorMessage");
        if (!String.IsNullOrEmpty(InvalidDateErrorMessage))
            this.InvalidDateErrorMessage = InvalidDateErrorMessage;

        string InvalidTimeErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidTimeErrorMessage");
        if (!String.IsNullOrEmpty(InvalidTimeErrorMessage))
            this.InvalidTimeErrorMessage = InvalidTimeErrorMessage;

        string RequiredGridViewsErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "RequiredGridViewsErrorMessage");
        if (!String.IsNullOrEmpty(RequiredGridViewsErrorMessage))
            this.RequiredGridViewsErrorMessage = RequiredGridViewsErrorMessage;

        string RequiredColumnsInGridViewsErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "RequiredColumnsInGridViewsErrorMessage");
        if (!String.IsNullOrEmpty(RequiredColumnsInGridViewsErrorMessage))
            this.RequiredColumnsInGridViewsErrorMessage = RequiredColumnsInGridViewsErrorMessage;

        string InvalidCurrencyGridViewsErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidCurrencyGridViewsErrorMessage");
        if (!String.IsNullOrEmpty(InvalidCurrencyGridViewsErrorMessage))
            this.InvalidCurrencyGridViewsErrorMessage = InvalidCurrencyGridViewsErrorMessage;

        string InvalidDateGridViewErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidDateGridViewErrorMessage");
        if (!String.IsNullOrEmpty(InvalidDateGridViewErrorMessage))
            this.InvalidDateGridViewErrorMessage = InvalidDateGridViewErrorMessage;

        string InvalidNumberGridViewErrorMessage = (string)GetGlobalResourceObject("WorkflowGenMy", "InvalidNumberGridViewErrorMessage");
        if (!String.IsNullOrEmpty(InvalidNumberGridViewErrorMessage))
            this.InvalidNumberGridViewErrorMessage = InvalidNumberGridViewErrorMessage;


        // Initialization
        this.FORM_DRAFT.Text = "N";

        // Inactive sections
        foreach (Control ctrl in this.Form.Controls)
        {
            if (ctrl is Panel && !ctrl.ID.Equals(this.CurrentWorkflowActionName))
            {
                if (((Panel)ctrl).CssClass == "Section")
                {
                    ((Panel)ctrl).CssClass = "Section SectionInactive";
                }
                foreach (Control childCtrl in ctrl.Controls)
                {
                    if (childCtrl is Panel)
                    {
                        if (((Panel)childCtrl).CssClass == "SectionHeader")
                        {
                            ((Panel)childCtrl).CssClass = "SectionHeader SectionHeaderInactive";
                        }
                    }
                }
            }
        }

    }

    /// <summary>
    /// PreRender.
    /// Code executed after WorkflowGen.My
    /// </summary>
    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (Page.FindControl("WFGENValidationSummary") == null)
        {
            ValidationSummary validationSummary = new ValidationSummary();
            validationSummary.ID = "WFGENValidationSummary";
            validationSummary.DisplayMode = ValidationSummaryDisplayMode.BulletList;
            validationSummary.ShowSummary = false;
            validationSummary.ShowMessageBox = true;
            validationSummary.HeaderText = "";
            validationSummary.ValidationGroup = "WFGENPage";
            Page.Form.Controls.Add(validationSummary);
        }

    }

    /// <summary>
    /// Page_PreRenderComplete.
    /// Code executed after Page_PreRender
    /// </summary>
    protected void Page_PreRenderComplete(object sender, EventArgs e)
    {

    }

    /// <summary>
    // Form Archive
    /// </summary>
    protected override void ChangeFormArchiveLayout()
    {
        base.ChangeFormArchiveLayout();

        foreach (Control ctrl in this.Form.Controls)
        {
            // Inactive sections
            if (ctrl is Panel)
            {
                if (((Panel)ctrl).CssClass == "Section")
                {
                    ((Panel)ctrl).CssClass = "Section SectionInactive";
                }
                foreach (Control childCtrl in ctrl.Controls)
                {
                   if (childCtrl is Panel)
                   {
                       if (((Panel)childCtrl).CssClass == "SectionHeader")
                       {
                           ((Panel)childCtrl).CssClass = "SectionHeader SectionHeaderInactive";
                       }
                   }
                }
            }
            if (ctrl is Button)
            {
                ctrl.Visible = false;
            }
        }
        hideCalendar(this.Form.Controls);
    }

    // Save As Draft
    protected void saveButton_Click(object sender, EventArgs e)
    {
        this.FORM_DRAFT.Text = "Y";
        
        // Removes all the validator controls
        foreach (Control ctrl in this.Form.Controls)
        {
            if (ctrl is BaseValidator)
            {
                ctrl.Visible = false;
            }
        }
        
        SubmitToWorkflow(true);
    }

    /// <summary>
    /// Hide calendars picture
    /// </summary>
    /// <param name="ctrl">Control</param>
    private void hideCalendar(ControlCollection ctrl)
    {
        foreach (Control c in ctrl)
        {
            if (c is eWorld.UI.CalendarPopup)
            {
                c.Visible = false;
            }
            else if (c.HasControls())
            {
                hideCalendar(c.Controls);
            }
        }
    }

    protected void GridView_DataBound(object sender, EventArgs e)
    {
        int idx = 0;
        Label lbl;
        string fieldDataType = null;
        string fieldFormat = null;
        decimal currencyValue = 0;
        double numericValue = 0;
        object computedResult = null;
        string result = null;
        string expression = null;
        string filter = null;
        string[] param = null;
        GridView gv = (GridView)sender;

        if (gv.DataSource != null)
        {
            DataTable dt = gv.DataSource as DataTable;
            foreach (TableCell cell in gv.FooterRow.Cells)
            {
                if (cell.HasControls())
                {
                    foreach (Control ctrl in cell.Controls)
                    {
                        if (ctrl is Label)
                        {
                            lbl = (Label)ctrl;
                            if (lbl != null && lbl.Text.StartsWith("="))
                            {
                                try
                                {
                                    expression = null;
                                    filter = null;
                                    param = lbl.Text.Split(',');
                                    expression = param[0].Substring(1);
                                    if (param.Length >= 2)
                                    {
                                        filter = param[1];
                                    }
                                    if (!expression.Contains("("))
                                    {
                                        if (lbl.HasAttributes && !string.IsNullOrEmpty(lbl.Attributes["wfgexpressionref"]))
                                        {
                                            expression = expression + "(" + lbl.Attributes["wfgexpressionref"] + ")";
                                        }
                                        else
                                        {
                                            expression = expression + "(" + dt.Columns[idx].ColumnName + ")";
                                        }
                                    }

                                    computedResult = dt.Compute(expression, filter);
                                    result = computedResult.ToString();

                                    if (computedResult != DBNull.Value)
                                    {
                                        DataControlField field = gv.Columns[idx];
                                        if (field is TemplateField)
                                        {
                                            foreach (GridViewRow row in gv.Rows)
                                            {
                                                if (row.RowType == DataControlRowType.DataRow)
                                                {
                                                    foreach (Control tmpCtrl in row.Cells[idx].Controls)
                                                    {
                                                        if (ctrl is ITextControl)
                                                        {
                                                            fieldDataType = ((WebControl)tmpCtrl).Attributes["FieldDataType"];
                                                            fieldFormat = ((WebControl)tmpCtrl).Attributes["FieldFormat"];
                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                        }

                                        if ((fieldDataType.Equals("Currency", StringComparison.OrdinalIgnoreCase) && Decimal.TryParse(result, out currencyValue)) || (fieldDataType.Equals("Numeric", StringComparison.OrdinalIgnoreCase) && Double.TryParse(result, out numericValue)))
                                        {
                                            result = FormatAccordingToFieldDataType(fieldDataType, fieldFormat, computedResult);
                                        }
                                    
                                    }
                                    lbl.Text = result;
                                }
                                catch (Exception err)
                                {
                                    lbl.Text = "<p><img src='../../App_Themes/Images/warning.gif' title='" + err.StackTrace + "' style='vertical-align:middle;'>"
                                             + err.Message + "<br>with expression: " + expression + "</p>";
                                }
                            }
                        }
                    }
                }
                idx++;
            }
        }
    }

    protected void GridView_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        string TextBoxId = null;
        eWorld.UI.CalendarPopup eWorldCalendar = null;

        // If the grid view is on Edit mode
        if (e.Row.RowState == DataControlRowState.Edit || (e.Row.RowState == (DataControlRowState.Alternate | DataControlRowState.Edit)))
        {
            foreach (TableCell cell in e.Row.Cells)
            {
                if (cell.HasControls())
                {
                    foreach (Control ctrl in cell.Controls)
                    {
                        // eWorld CalendarPopup
                        if (ctrl.GetType().Name == "CalendarPopup")
                        {
                            TextBoxId = "";
                            // Get the unique ID of the CalendarPopup (SECTION_GRIDVIEW_ctl0X_SECTION_GRIDVIEW_TEXTBOX_CAL)
                            eWorldCalendar = (eWorld.UI.CalendarPopup)ctrl;
                            // Get the unique ID of the textbox SECTION_GRIDVIEW_ctl0X_SECTION_GRIDVIEW_TEXTBOX associated to the CalendarPopup (remove the end _CAL)
                            TextBoxId = eWorldCalendar.UniqueID.Substring(0, eWorldCalendar.UniqueID.Length - 4).Replace("$", "_");
                            // Update the OnClientChange property with the unique IDs
                            eWorldCalendar.OnClientChange = "document.forms[0]['" + TextBoxId + "'].value = document.forms[0]." + eWorldCalendar.UniqueID.Replace("$", "_") + "_hidden.value;";
                        }
                    }
                }
            }
        }
    }

    protected string Compute(System.Data.DataRowView row, string columnName, string expression)
    {
      row.Row.Table.Columns[columnName].Expression = Convert.ToString(expression);
      return Convert.ToString(row[columnName]);
    }

    protected void List_OnDataBound(object sender, EventArgs e)
    {
        ListControl list = null;
        ListItem li = null;
        
        if (sender is DropDownList)
        {
            list = sender as DropDownList;
        }
        else if (sender is ListBox)
        {
            list = sender as ListBox;
        }
        
        if (list != null)
        {
            if (!Page.IsPostBack)
            {
                li = list.Items.FindByValue(Convert.ToString(FormData.Tables["Table1"].Rows[0][list.ID]));
                
                if (li != null)
                {
                    if (!li.Selected)
                    {
                        // Note: WorkflowGen.My uses SelectedIndex. Using SelectedValue might cause exceptions 
                        list.SelectedIndex = list.Items.IndexOf(li);
                    }
                }
            }
        }
    }

    protected void SetRequiredField(WebControl ctrl, bool condition)
    {
        if(!IsPostBack)
        {
            this.FieldsHelper.BackupControlStyleProperties(ctrl,false);
        }

        if (condition && ctrl.Visible && ctrl.Enabled)
        {
            this.FieldsHelper.RequiredMessage = RequiredFieldsErrorMessage;
            this.FieldsHelper.RequiredBorderColor = RequiredFieldsBorderColor;
            this.FieldsHelper.RequiredFieldsPattern = ctrl.ID;
            this.FieldsHelper.RequiredFieldsExecute(true);
        }
        else
        {

            if (ctrl is GridView)
            {
                ctrl.Attributes.Remove("Required");
            }
            else if (ctrl is WorkflowFileUpload)
            {
                this.FieldsHelper.RestoreControlStyleProperties(((WorkflowFileUpload)ctrl).RequiredStyleWebControl);
            }
            else
            {
                this.FieldsHelper.RestoreControlStyleProperties(ctrl);
            }
        }
    }

    protected void SetRequiredField(WorkflowFileUpload ctrl, bool condition)
    {
        SetRequiredField((WebControl)ctrl, condition);
    }

    protected void SetRequiredField(UserControl ctrl, bool condition)
    {
        if (condition && ctrl.Visible)
        {
            this.FieldsHelper.RequiredMessage = RequiredFieldsErrorMessage;
            this.FieldsHelper.RequiredBorderColor = RequiredFieldsBorderColor;
            this.FieldsHelper.RequiredFieldsPattern = ctrl.ID + ".*";
            this.FieldsHelper.RequiredFieldsExecute(true);
        }
        else
        {
            foreach (Control childCtrl in ctrl.Controls)
            {
                if (!String.IsNullOrEmpty(childCtrl.ID))
                {
                    if (childCtrl is WorkflowFileUpload || childCtrl is WebControl)
                    {
                        SetRequiredField((WebControl)childCtrl, false);
                    }
                }
            }
        }
    }

    protected void SetRequiredField(Panel ctrl, bool condition)
    {
        foreach (Control childCtrl in ctrl.Controls)
        {
            if (childCtrl is Panel && !String.IsNullOrEmpty(childCtrl.ID) && childCtrl.ID.StartsWith(ctrl.ID + "_ROW_"))
            {
                foreach (Control grandChildCtrl in childCtrl.Controls)
                {
                    if (!String.IsNullOrEmpty(grandChildCtrl.ID) && grandChildCtrl.ID.StartsWith(ctrl.ID + "_"))
                    {
                        if (grandChildCtrl is WorkflowFileUpload || (grandChildCtrl is WebControl && !(grandChildCtrl is Label)))
                        {
                            SetRequiredField((WebControl)grandChildCtrl, condition);
                        }
                        else if (grandChildCtrl is UserControl)
                        {
                            SetRequiredField((UserControl)grandChildCtrl, condition);
                        }
                    }
                }
            }
        }
    }

    protected void SetReadOnlyField(WebControl ctrl, bool condition)
    {
        if (condition)
        {
            if (ctrl is GridView)
            {
                ctrl.Enabled = false;
            }
            else
            {
                this.FieldsHelper.ReadOnlyBorderColor = ReadOnlyFieldsBorderColor;
                this.FieldsHelper.ReadOnlyFieldsPattern = ctrl.ID;
                this.FieldsHelper.ReadOnlyFieldsExecute();
            }
        }
        else
        {
            if (ctrl is GridView)
            {
                ctrl.Enabled = true;
            }
            else
            {
                Type type = ctrl.GetType();
                System.Reflection.PropertyInfo piReadOnly = type.GetProperty("ReadOnly");
                if (piReadOnly != null)
                {
                    piReadOnly.SetValue(ctrl, false, null);
                }

                ctrl.Enabled = true;

                if (ctrl is CheckBoxList)
                {
                    foreach (ListItem cbItem in ((CheckBoxList)ctrl).Items)
                    {
                        cbItem.Enabled = true;
                    }
                }
                else if (ctrl is TextBox)
                {
                    Control calendar = Page.FindControl(ctrl.ID + "_CAL");
                    WebControl cal;

                    if (calendar != null && (cal = calendar as WebControl) != null)
                    {
                        cal.Enabled = true;
                    }
                }

                ctrl.ForeColor = System.Drawing.Color.Empty;
                ctrl.BackColor = System.Drawing.Color.Empty;
                ctrl.BorderColor = System.Drawing.Color.Empty;
                ctrl.BorderStyle = BorderStyle.NotSet;
                ctrl.BorderWidth = Unit.Empty;
            }
        }

        // Disable the associated FieldCaptionLabel of the field
        Control fieldLabelCtrl = Page.FindControl(ctrl.ID + "_LABEL");
        Label fieldLabel;
        if ((fieldLabel = fieldLabelCtrl as Label) != null && fieldLabel.CssClass == "FieldCaptionLabel")
        {
            fieldLabel.Enabled = !condition;
        }
    }

    protected void SetReadOnlyField(UserControl ctrl, bool condition)
    {
        if (condition)
        {
            this.FieldsHelper.ReadOnlyBorderColor = ReadOnlyFieldsBorderColor;
            this.FieldsHelper.ReadOnlyFieldsPattern = ctrl.ID + ".*";
            this.FieldsHelper.ReadOnlyFieldsExecute();
        }
        else
        {
            foreach (Control childCtrl in ctrl.Controls)
            {
                if (!String.IsNullOrEmpty(childCtrl.ID))
                {
                    if (childCtrl is WebControl)
                    {
                        SetReadOnlyField((WebControl)childCtrl, condition);
                    }
                }
            }
        }

        // Disable the associated FieldCaptionLabel of the field
        Control fieldLabelCtrl = Page.FindControl(ctrl.ID + "_LABEL");
        Label fieldLabel;
        if ((fieldLabel = fieldLabelCtrl as Label) != null && fieldLabel.CssClass == "FieldCaptionLabel")
        {
            fieldLabel.Enabled = !condition;
        }
    }

    protected void SetReadOnlyField(Panel ctrl, bool condition)
    {
        foreach (Control childCtrl in ctrl.Controls)
        {
            if (childCtrl is Panel && !String.IsNullOrEmpty(childCtrl.ID) && childCtrl.ID.StartsWith(ctrl.ID + "_ROW_"))
            {
                foreach (Control grandChildCtrl in childCtrl.Controls)
                {
                    if (!String.IsNullOrEmpty(grandChildCtrl.ID) && grandChildCtrl.ID.StartsWith(ctrl.ID + "_"))
                    {
                        if (grandChildCtrl is WebControl && ((WebControl)grandChildCtrl).CssClass != "FieldCaptionLabel")
                        {
                            SetReadOnlyField((WebControl)grandChildCtrl, condition);
                        }
                        else if (grandChildCtrl is UserControl)
                        {
                            SetReadOnlyField((UserControl)grandChildCtrl, condition);
                        }
                    }
                }
            }
        }
    }

    protected void SetHiddenField(Control ctrl, bool condition)
    {
          if (ctrl is Panel)
          {
            ctrl.Visible = !condition;
          }
          else if (ctrl.Parent != null && ctrl.Parent is Panel)
          {
            ctrl.Parent.Visible = !condition;
          }
    }


}
